<template>
	<view class="pages">
		<view class="page-wrap">
			
				<u-search
					placeholder="搜索关键词" 
					:clearabled="true"
					:showAction="false"
					height="80rpx"
					@search="search"
					@custom="search"
					@change="titleChange"
					@clear="reloadList"
					bgColor="#fff"
					borderColor="#00A447"
					v-model="params.title">
				</u-search>
		
		<view class="tabs-wrap" v-if="showTabs">
			<u-tabs 
			:list="tabsList" 
			lineColor="#00A447" 
			 :activeStyle="{color:'#333','font-weight': '600','font-size':'30rpx'}"
			 :inactiveStyle="{color:'#999'}"
			@click="tabsClick"></u-tabs>
		</view>
		<mescroll-body class="" ref="mescrollRef" @init="mescrollInit" @down="downCallback" @up="upCallback" :down="downOption" :up="upOption">
			<view class="page-wrap" >
				<view class="course u-flex u-col-top" v-for="(item,index) in dataList" :key="item.id" @click="$u.route('/study/studydetails',{id:item.id})">
					<view class="pic">
						<u--image mode="scaleToFill" width="180rpx" height="170rpx" radius="10rpx" :showLoading="true" class="image" :src="item.mainImg"></u--image>
					</view>
					<view class="text">
						<view class="title ellipsis-2">
							<text class="new" v-if="index<9">最新</text>
							{{item.title}}
						</view>
						<view class="classify">
							<!-- <text class="classify-item">测试</text> -->
						</view>
						<view class="studyUserNum">
							{{item.studyUserNum}}人已学习
						</view>
					</view>
				</view>
			</view>
		</mescroll-body>
			
		</view>
	</view>
</template>

<script>
	// 引入mescroll-mixins.js
	import MescrollMixin from "@/uni_modules/mescroll-uni/components/mescroll-uni/mescroll-mixins.js";
	export default {
		mixins: [MescrollMixin], // 使用mixin
		data() {
			return {
				downOption: {},
				// 上拉加载的配置(可选, 绝大部分情况无需配置)
				upOption: {
					page: {
						size: 10 // 每页数据的数量,默认10
					},
					noMoreSize: 3, // 配置列表的总数量要大于等于5条才显示'-- END --'的提示
					empty: {
						tip: '暂无相关学习资料'
					}
				},
				tabsList:[],
				params:{
					title:'',
					classifyId:'',
				},
				activeIndex:0,
				// 列表数据
				dataList: [],
				showTabs:true
			}
		},
		onShow() {
			// this.getclassify();
		},
		onLoad() {

		},
		methods: {
			/*下拉刷新的回调, 重置列表为第一页 (此处可删,mixins已默认)
			downCallback(){
				this.mescroll.resetUpScroll();
			},
			/*上拉加载的回调*/
			upCallback(page) {
				let that = this;
				// 此处可以继续请求其他接口
				// if(page.num == 1){
				// 	// 请求其他接口...
				// }
				
				if(!this.params.classifyId){
					this.getclassify();
					return // 此处return,先获取xx
				}
				
				let pageNum = page.num; // 页码, 默认从1开始
				let pageSize = page.size; // 页长, 默认每页10条
				let params = Object.assign(this.params,{pageNum:pageNum,pageSize:pageSize});
				if(params.title){
					params.classifyId = '';
					this.showTabs = false;
				}else{
					this.showTabs = true;
				}
				// console.log('this.params',this.params);
				this.$u.api.studyLib(params).then(data => {
					// console.log('data',JSON.parse(JSON.stringify(data)));
					// 接口返回的当前页数据列表 (数组)
					let curPageData = data.data.rows;
					// console.log('curPageData',JSON.parse(JSON.stringify(curPageData)));
					// 接口返回的当前页数据长度 (如列表有26个数据,当前页返回8个,则curPageLen=8)
					let curPageLen = curPageData.length; 
					// 接口返回的总页数 (如列表有26个数据,每页10条,共3页; 则totalPage=3)
					// let totalPage =  data.data.data.totalPage; 
					// 接口返回的总数据量(如列表有26个数据,每页10条,共3页; 则totalSize=26)
					let totalSize = data.data.total; 
					// 接口返回的是否有下一页 (true/false)
					// let hasNext = data.xxx; 
					// console.log('totalPage',totalPage,'curPageLen',curPageLen);
					//设置列表数据
					if(page.num == 1) this.dataList = []; //如果是第一页需手动置空列表
					this.dataList = this.dataList.concat(curPageData); //追加新数据
					// 请求成功,隐藏加载状态
					//方法一(推荐): 后台接口有返回列表的总页数 totalPage
					// this.mescroll.endByPage(curPageLen, totalPage); 
					//方法二(推荐): 后台接口有返回列表的总数据量 totalSize
					this.mescroll.endBySize(curPageLen, totalSize); 
				}).catch(err => {
					this.mescroll.endErr()
					console.log(err)
				});	
			},
			/*若希望重新加载列表,只需调用此方法即可(内部会自动page.num=1,再主动触发up.callback)*/
			reloadList() {
				this.mescroll.resetUpScroll();
			},
			search(e){
				this.mescroll.resetUpScroll();
				// this.reloadList();
				// console.log('search',e)
			},
			getclassify(){
				this.$u.api.getclassify({pageNum:1,pageSize:200}).then(res=>{
					this.tabsList = res.data.rows.map(item=>{
						return {name:item.classifyName,id:item.id}
					});
					this.params.classifyId = this.tabsList[0].id;
					this.mescroll.resetUpScroll();
				}).catch(err=>{
					this.mescroll.endErr()
					console.log('getclassify',err);
				})				
			},
			tabsClick(item){
				// console.log('itemitemitem',item);
				this.activeIndex = item.index;
				this.params.classifyId = item.id;
				this.reloadList()
			},
			titleChange(title){
				let that = this;
				if(!title){
					setTimeout(()=>{
						that.search()
					},500)
				}
			}
		}
	}
</script>

<style lang="scss" scoped>

</style>